<?php

/**
 * perfil_acceso actions.
 *
 * @package    canon
 * @subpackage perfil_acceso
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class perfil_accesoActions extends sfQuery {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 200;
            }

            /*
             * variables de filtro
             */
            $wherePerfil = ' ';
            if (isset($request['id_perfil'])) {
                $wherePerfil = " AND tab0.id_perfil = '" . $request['id_perfil'] . "' ";
            }
            $whereModulo = ' ';
            if (isset($request['id_modulo'])) {
                $whereModulo = " AND tab1.id_modulo = '" . $request['id_modulo'] . "' ";
            }
            
                 // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_perfil_acceso');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                    $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }
            
            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from(

select 
tabla.id_acceso, tabla.id_acceso_padre, tabla.cod_func, tabla.es_funcion, tabla.rotulo, tabla.id_modulo, tabla.estado, tabla2.id_perfil  
from (
            
    select 
    tab1.id_acceso, tab0.id_acceso_padre, tab1.cod_func, tab1.es_funcion, tab1.rotulo, tab1.id_modulo, tab1.estado, tab0.orden 
    from ca_acceso_acceso tab0 
    join ca_acceso tab1 on tab0.id_acceso_hijo=tab1.id_acceso
    where 1=1 $whereModulo
    
    ORDER BY id_acceso_padre, orden   
            
)tabla

left join (
            
    select tab0.id_acceso, tab0.id_perfil from ca_perfil_acceso tab0 where 1=1 $wherePerfil 
    
)tabla2

on tabla.id_acceso=tabla2.id_acceso
    
)tabla
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {


                /*
                 * Obtiene los accesos para un perfil
                 */
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
            
select 
tabla.id_acceso, tabla.id_acceso_padre, tabla.cod_func, tabla.es_funcion, tabla.rotulo, tabla.id_modulo, tabla.estado, tabla2.id_perfil  
from (
            
    select 
    tab1.id_acceso, tab0.id_acceso_padre, tab1.cod_func, tab1.es_funcion, tab1.rotulo, tab1.id_modulo, tab1.estado, tab0.orden 
    from ca_acceso_acceso tab0 
    join ca_acceso tab1 on tab0.id_acceso_hijo=tab1.id_acceso
    where 1=1 $whereModulo
    
    ORDER BY id_acceso_padre, orden   
            
)tabla

left join (
            
    select tab0.id_acceso, tab0.id_perfil from ca_perfil_acceso tab0 where 1=1 $wherePerfil 
    
)tabla2

on tabla.id_acceso=tabla2.id_acceso
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;


                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);            

                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[PERFIL_ACCESOS] Consulta exitosa.");
            } else {

                $mensaje = "[PERFIL_ACCESOS] No hay registros de consulta.";
                $this->status = 1;
                $this->mensajeError = $mensaje;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "ERROR!!!";
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage("Error: " . $e->getMessage());
        }
    }

    public function executeAdd(sfWebRequest $request) {
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */

            $wherePerfil = ' ';

            $wherePerfil = " AND id_perfil = " . $request['id_perfil'];

            $Perfil = $request['id_perfil'];
            $Acceso = $request['id_acceso'];

            $sql = <<<EOD
            
INSERT INTO ca_perfil_acceso (id_perfil, id_acceso) values ($Perfil,$Acceso)


EOD;

            //Insertar nuevos accesos
            CN_TABLE::executeSQL($sql);

            $this->logMessage("[ACCESOS-ADD] Registro Exitoso en el perfil: " . $Perfil);


            $sql = <<<EOD
            
SELECT * FROM  ca_perfil_acceso WHERE id_acceso!=-1 $wherePerfil


EOD;

            //Insertar nuevos accesos
            $rec = CN_TABLE::executeSQL($sql);
            $this->list_data = $rec;
            $this->status = 0;
        } catch (Exception $e) {


            $this->logMessage("[ACCESOS-ADD] Registro Fallido en el perfil: " . $Perfil);
            $this->status = 1;
        }
    }

    public function executeRemove(sfWebRequest $request) {
        //Se eliminan los accesos asociados a un perfil

        $Perfil = $request['id_perfil'];
        $wherePerfil = ' ';

        $wherePerfil = " AND id_perfil = " . $request['id_perfil'];


        try {
            $sql = <<<EOD
            
 DELETE FROM ca_perfil_acceso  WHERE id_perfil!=-1 $wherePerfil

EOD;

            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            $this->logMessage("[ACCESOS-REMOVE] Eliminación Exitosa del Perfil: " . $Perfil);

            $records = array();
            $records[0]["id_perfil"] = $Perfil;

            $this->list_data = $records;
            $this->status = 0;
        } catch (Exception $e) {
            $this->logMessage("[ACCESOS-REMOVE] Eliminación Fallida del Perfil: " . $Perfil);
            $this->status = 1;
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
